<?php
# Extension for MediaWiki for creating links to BioBrick parts
# To activate the extension, include it from your LocalSettings.php
# Author: Austin Che 

$wgExtensionFunctions[] = "wfPartsRegistryExtension";
$wgExtensionCredits['parserhook'][] = array(
    'name' => 'PartsRegistry',
    'version' => '2006/05/26',
    'author' => 'Austin Che',
    'url' => 'http://openwetware.org/wiki/User:Austin/Extensions/PartsRegistry',
    'description' => 'Enable linking to http://parts.mit.edu/',
);

function wfPartsRegistryExtension()
{
    global $wgParser;
    $wgParser->setHook( "bbpart", "renderPart" );
}

function renderPart( $input, $argv )
{
    $matches = array();
    if (preg_match("/(BB.*_)?([-+a-zA-Z_0-9]+)/", $input, $matches))
    {
        $part = strtoupper($matches[2]);
        if ($matches[1])
            $part = $matches[1] . $part;
        else
            $part = "BBa_" . $part;
        return "<a href='http://parts.mit.edu/registry/index.php/Part:$part'" .
                " class='external' title='$input'>$input</a>"; 
    }
    else
        return "";
}
?>
